// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: device_properties.proto

#ifndef PROTOBUF_device_5fproperties_2eproto__INCLUDED
#define PROTOBUF_device_5fproperties_2eproto__INCLUDED

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 3005000
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 3005000 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/metadata.h>
#include <google/protobuf/message.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include <google/protobuf/map.h>  // IWYU pragma: export
#include <google/protobuf/map_entry.h>
#include <google/protobuf/map_field_inl.h>
#include <google/protobuf/unknown_field_set.h>
#include "value.pb.h"
// @@protoc_insertion_point(includes)

namespace protobuf_device_5fproperties_2eproto {
// Internal implementation detail -- do not use these members.
struct TableStruct {
  static const ::google::protobuf::internal::ParseTableField entries[];
  static const ::google::protobuf::internal::AuxillaryParseTableField aux[];
  static const ::google::protobuf::internal::ParseTable schema[6];
  static const ::google::protobuf::internal::FieldMetadata field_metadata[];
  static const ::google::protobuf::internal::SerializationTable serialization_table[];
  static const ::google::protobuf::uint32 offsets[];
};
void AddDescriptors();
void InitDefaultsReadDevicePropertiesMessageImpl();
void InitDefaultsReadDevicePropertiesMessage();
void InitDefaultsDeviceProperties_PropertiesEntry_DoNotUseImpl();
void InitDefaultsDeviceProperties_PropertiesEntry_DoNotUse();
void InitDefaultsDevicePropertiesImpl();
void InitDefaultsDeviceProperties();
void InitDefaultsReadDeviceAttributeMetaMessageImpl();
void InitDefaultsReadDeviceAttributeMetaMessage();
void InitDefaultsDeviceAttributeMeta_MetaEntry_DoNotUseImpl();
void InitDefaultsDeviceAttributeMeta_MetaEntry_DoNotUse();
void InitDefaultsDeviceAttributeMetaImpl();
void InitDefaultsDeviceAttributeMeta();
inline void InitDefaults() {
  InitDefaultsReadDevicePropertiesMessage();
  InitDefaultsDeviceProperties_PropertiesEntry_DoNotUse();
  InitDefaultsDeviceProperties();
  InitDefaultsReadDeviceAttributeMetaMessage();
  InitDefaultsDeviceAttributeMeta_MetaEntry_DoNotUse();
  InitDefaultsDeviceAttributeMeta();
}
}  // namespace protobuf_device_5fproperties_2eproto
namespace mascot {
class DeviceAttributeMeta;
class DeviceAttributeMetaDefaultTypeInternal;
extern DeviceAttributeMetaDefaultTypeInternal _DeviceAttributeMeta_default_instance_;
class DeviceAttributeMeta_MetaEntry_DoNotUse;
class DeviceAttributeMeta_MetaEntry_DoNotUseDefaultTypeInternal;
extern DeviceAttributeMeta_MetaEntry_DoNotUseDefaultTypeInternal _DeviceAttributeMeta_MetaEntry_DoNotUse_default_instance_;
class DeviceProperties;
class DevicePropertiesDefaultTypeInternal;
extern DevicePropertiesDefaultTypeInternal _DeviceProperties_default_instance_;
class DeviceProperties_PropertiesEntry_DoNotUse;
class DeviceProperties_PropertiesEntry_DoNotUseDefaultTypeInternal;
extern DeviceProperties_PropertiesEntry_DoNotUseDefaultTypeInternal _DeviceProperties_PropertiesEntry_DoNotUse_default_instance_;
class ReadDeviceAttributeMetaMessage;
class ReadDeviceAttributeMetaMessageDefaultTypeInternal;
extern ReadDeviceAttributeMetaMessageDefaultTypeInternal _ReadDeviceAttributeMetaMessage_default_instance_;
class ReadDevicePropertiesMessage;
class ReadDevicePropertiesMessageDefaultTypeInternal;
extern ReadDevicePropertiesMessageDefaultTypeInternal _ReadDevicePropertiesMessage_default_instance_;
}  // namespace mascot
namespace mascot {

// ===================================================================

class ReadDevicePropertiesMessage : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.ReadDevicePropertiesMessage) */ {
 public:
  ReadDevicePropertiesMessage();
  virtual ~ReadDevicePropertiesMessage();

  ReadDevicePropertiesMessage(const ReadDevicePropertiesMessage& from);

  inline ReadDevicePropertiesMessage& operator=(const ReadDevicePropertiesMessage& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  ReadDevicePropertiesMessage(ReadDevicePropertiesMessage&& from) noexcept
    : ReadDevicePropertiesMessage() {
    *this = ::std::move(from);
  }

  inline ReadDevicePropertiesMessage& operator=(ReadDevicePropertiesMessage&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const ReadDevicePropertiesMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const ReadDevicePropertiesMessage* internal_default_instance() {
    return reinterpret_cast<const ReadDevicePropertiesMessage*>(
               &_ReadDevicePropertiesMessage_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    0;

  void Swap(ReadDevicePropertiesMessage* other);
  friend void swap(ReadDevicePropertiesMessage& a, ReadDevicePropertiesMessage& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline ReadDevicePropertiesMessage* New() const PROTOBUF_FINAL { return New(NULL); }

  ReadDevicePropertiesMessage* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const ReadDevicePropertiesMessage& from);
  void MergeFrom(const ReadDevicePropertiesMessage& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(ReadDevicePropertiesMessage* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string deviceName = 1;
  void clear_devicename();
  static const int kDeviceNameFieldNumber = 1;
  const ::std::string& devicename() const;
  void set_devicename(const ::std::string& value);
  #if LANG_CXX11
  void set_devicename(::std::string&& value);
  #endif
  void set_devicename(const char* value);
  void set_devicename(const char* value, size_t size);
  ::std::string* mutable_devicename();
  ::std::string* release_devicename();
  void set_allocated_devicename(::std::string* devicename);

  // @@protoc_insertion_point(class_scope:mascot.ReadDevicePropertiesMessage)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr devicename_;
  mutable int _cached_size_;
  friend struct ::protobuf_device_5fproperties_2eproto::TableStruct;
  friend void ::protobuf_device_5fproperties_2eproto::InitDefaultsReadDevicePropertiesMessageImpl();
};
// -------------------------------------------------------------------

class DeviceProperties_PropertiesEntry_DoNotUse : public ::google::protobuf::internal::MapEntry<DeviceProperties_PropertiesEntry_DoNotUse, 
    ::std::string, ::mascot::AttributeValue,
    ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
    ::google::protobuf::internal::WireFormatLite::TYPE_MESSAGE,
    0 > {
public:
  typedef ::google::protobuf::internal::MapEntry<DeviceProperties_PropertiesEntry_DoNotUse, 
    ::std::string, ::mascot::AttributeValue,
    ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
    ::google::protobuf::internal::WireFormatLite::TYPE_MESSAGE,
    0 > SuperType;
  DeviceProperties_PropertiesEntry_DoNotUse();
  DeviceProperties_PropertiesEntry_DoNotUse(::google::protobuf::Arena* arena);
  void MergeFrom(const DeviceProperties_PropertiesEntry_DoNotUse& other);
  static const DeviceProperties_PropertiesEntry_DoNotUse* internal_default_instance() { return reinterpret_cast<const DeviceProperties_PropertiesEntry_DoNotUse*>(&_DeviceProperties_PropertiesEntry_DoNotUse_default_instance_); }
  void MergeFrom(const ::google::protobuf::Message& other) PROTOBUF_FINAL;
  ::google::protobuf::Metadata GetMetadata() const;
};

// -------------------------------------------------------------------

class DeviceProperties : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.DeviceProperties) */ {
 public:
  DeviceProperties();
  virtual ~DeviceProperties();

  DeviceProperties(const DeviceProperties& from);

  inline DeviceProperties& operator=(const DeviceProperties& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  DeviceProperties(DeviceProperties&& from) noexcept
    : DeviceProperties() {
    *this = ::std::move(from);
  }

  inline DeviceProperties& operator=(DeviceProperties&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const DeviceProperties& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const DeviceProperties* internal_default_instance() {
    return reinterpret_cast<const DeviceProperties*>(
               &_DeviceProperties_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    2;

  void Swap(DeviceProperties* other);
  friend void swap(DeviceProperties& a, DeviceProperties& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline DeviceProperties* New() const PROTOBUF_FINAL { return New(NULL); }

  DeviceProperties* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const DeviceProperties& from);
  void MergeFrom(const DeviceProperties& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(DeviceProperties* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------


  // accessors -------------------------------------------------------

  // map<string, .mascot.AttributeValue> properties = 2;
  int properties_size() const;
  void clear_properties();
  static const int kPropertiesFieldNumber = 2;
  const ::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >&
      properties() const;
  ::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >*
      mutable_properties();

  // string deviceName = 1;
  void clear_devicename();
  static const int kDeviceNameFieldNumber = 1;
  const ::std::string& devicename() const;
  void set_devicename(const ::std::string& value);
  #if LANG_CXX11
  void set_devicename(::std::string&& value);
  #endif
  void set_devicename(const char* value);
  void set_devicename(const char* value, size_t size);
  ::std::string* mutable_devicename();
  ::std::string* release_devicename();
  void set_allocated_devicename(::std::string* devicename);

  // @@protoc_insertion_point(class_scope:mascot.DeviceProperties)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::MapField<
      DeviceProperties_PropertiesEntry_DoNotUse,
      ::std::string, ::mascot::AttributeValue,
      ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
      ::google::protobuf::internal::WireFormatLite::TYPE_MESSAGE,
      0 > properties_;
  ::google::protobuf::internal::ArenaStringPtr devicename_;
  mutable int _cached_size_;
  friend struct ::protobuf_device_5fproperties_2eproto::TableStruct;
  friend void ::protobuf_device_5fproperties_2eproto::InitDefaultsDevicePropertiesImpl();
};
// -------------------------------------------------------------------

class ReadDeviceAttributeMetaMessage : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.ReadDeviceAttributeMetaMessage) */ {
 public:
  ReadDeviceAttributeMetaMessage();
  virtual ~ReadDeviceAttributeMetaMessage();

  ReadDeviceAttributeMetaMessage(const ReadDeviceAttributeMetaMessage& from);

  inline ReadDeviceAttributeMetaMessage& operator=(const ReadDeviceAttributeMetaMessage& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  ReadDeviceAttributeMetaMessage(ReadDeviceAttributeMetaMessage&& from) noexcept
    : ReadDeviceAttributeMetaMessage() {
    *this = ::std::move(from);
  }

  inline ReadDeviceAttributeMetaMessage& operator=(ReadDeviceAttributeMetaMessage&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const ReadDeviceAttributeMetaMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const ReadDeviceAttributeMetaMessage* internal_default_instance() {
    return reinterpret_cast<const ReadDeviceAttributeMetaMessage*>(
               &_ReadDeviceAttributeMetaMessage_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    3;

  void Swap(ReadDeviceAttributeMetaMessage* other);
  friend void swap(ReadDeviceAttributeMetaMessage& a, ReadDeviceAttributeMetaMessage& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline ReadDeviceAttributeMetaMessage* New() const PROTOBUF_FINAL { return New(NULL); }

  ReadDeviceAttributeMetaMessage* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const ReadDeviceAttributeMetaMessage& from);
  void MergeFrom(const ReadDeviceAttributeMetaMessage& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(ReadDeviceAttributeMetaMessage* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string deviceName = 1;
  void clear_devicename();
  static const int kDeviceNameFieldNumber = 1;
  const ::std::string& devicename() const;
  void set_devicename(const ::std::string& value);
  #if LANG_CXX11
  void set_devicename(::std::string&& value);
  #endif
  void set_devicename(const char* value);
  void set_devicename(const char* value, size_t size);
  ::std::string* mutable_devicename();
  ::std::string* release_devicename();
  void set_allocated_devicename(::std::string* devicename);

  // string attributeName = 2;
  void clear_attributename();
  static const int kAttributeNameFieldNumber = 2;
  const ::std::string& attributename() const;
  void set_attributename(const ::std::string& value);
  #if LANG_CXX11
  void set_attributename(::std::string&& value);
  #endif
  void set_attributename(const char* value);
  void set_attributename(const char* value, size_t size);
  ::std::string* mutable_attributename();
  ::std::string* release_attributename();
  void set_allocated_attributename(::std::string* attributename);

  // @@protoc_insertion_point(class_scope:mascot.ReadDeviceAttributeMetaMessage)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr devicename_;
  ::google::protobuf::internal::ArenaStringPtr attributename_;
  mutable int _cached_size_;
  friend struct ::protobuf_device_5fproperties_2eproto::TableStruct;
  friend void ::protobuf_device_5fproperties_2eproto::InitDefaultsReadDeviceAttributeMetaMessageImpl();
};
// -------------------------------------------------------------------

class DeviceAttributeMeta_MetaEntry_DoNotUse : public ::google::protobuf::internal::MapEntry<DeviceAttributeMeta_MetaEntry_DoNotUse, 
    ::std::string, ::std::string,
    ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
    ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
    0 > {
public:
  typedef ::google::protobuf::internal::MapEntry<DeviceAttributeMeta_MetaEntry_DoNotUse, 
    ::std::string, ::std::string,
    ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
    ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
    0 > SuperType;
  DeviceAttributeMeta_MetaEntry_DoNotUse();
  DeviceAttributeMeta_MetaEntry_DoNotUse(::google::protobuf::Arena* arena);
  void MergeFrom(const DeviceAttributeMeta_MetaEntry_DoNotUse& other);
  static const DeviceAttributeMeta_MetaEntry_DoNotUse* internal_default_instance() { return reinterpret_cast<const DeviceAttributeMeta_MetaEntry_DoNotUse*>(&_DeviceAttributeMeta_MetaEntry_DoNotUse_default_instance_); }
  void MergeFrom(const ::google::protobuf::Message& other) PROTOBUF_FINAL;
  ::google::protobuf::Metadata GetMetadata() const;
};

// -------------------------------------------------------------------

class DeviceAttributeMeta : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.DeviceAttributeMeta) */ {
 public:
  DeviceAttributeMeta();
  virtual ~DeviceAttributeMeta();

  DeviceAttributeMeta(const DeviceAttributeMeta& from);

  inline DeviceAttributeMeta& operator=(const DeviceAttributeMeta& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  DeviceAttributeMeta(DeviceAttributeMeta&& from) noexcept
    : DeviceAttributeMeta() {
    *this = ::std::move(from);
  }

  inline DeviceAttributeMeta& operator=(DeviceAttributeMeta&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const DeviceAttributeMeta& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const DeviceAttributeMeta* internal_default_instance() {
    return reinterpret_cast<const DeviceAttributeMeta*>(
               &_DeviceAttributeMeta_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    5;

  void Swap(DeviceAttributeMeta* other);
  friend void swap(DeviceAttributeMeta& a, DeviceAttributeMeta& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline DeviceAttributeMeta* New() const PROTOBUF_FINAL { return New(NULL); }

  DeviceAttributeMeta* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const DeviceAttributeMeta& from);
  void MergeFrom(const DeviceAttributeMeta& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(DeviceAttributeMeta* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------


  // accessors -------------------------------------------------------

  // map<string, string> meta = 3;
  int meta_size() const;
  void clear_meta();
  static const int kMetaFieldNumber = 3;
  const ::google::protobuf::Map< ::std::string, ::std::string >&
      meta() const;
  ::google::protobuf::Map< ::std::string, ::std::string >*
      mutable_meta();

  // string deviceName = 1;
  void clear_devicename();
  static const int kDeviceNameFieldNumber = 1;
  const ::std::string& devicename() const;
  void set_devicename(const ::std::string& value);
  #if LANG_CXX11
  void set_devicename(::std::string&& value);
  #endif
  void set_devicename(const char* value);
  void set_devicename(const char* value, size_t size);
  ::std::string* mutable_devicename();
  ::std::string* release_devicename();
  void set_allocated_devicename(::std::string* devicename);

  // string attributeName = 2;
  void clear_attributename();
  static const int kAttributeNameFieldNumber = 2;
  const ::std::string& attributename() const;
  void set_attributename(const ::std::string& value);
  #if LANG_CXX11
  void set_attributename(::std::string&& value);
  #endif
  void set_attributename(const char* value);
  void set_attributename(const char* value, size_t size);
  ::std::string* mutable_attributename();
  ::std::string* release_attributename();
  void set_allocated_attributename(::std::string* attributename);

  // @@protoc_insertion_point(class_scope:mascot.DeviceAttributeMeta)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::MapField<
      DeviceAttributeMeta_MetaEntry_DoNotUse,
      ::std::string, ::std::string,
      ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
      ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
      0 > meta_;
  ::google::protobuf::internal::ArenaStringPtr devicename_;
  ::google::protobuf::internal::ArenaStringPtr attributename_;
  mutable int _cached_size_;
  friend struct ::protobuf_device_5fproperties_2eproto::TableStruct;
  friend void ::protobuf_device_5fproperties_2eproto::InitDefaultsDeviceAttributeMetaImpl();
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// ReadDevicePropertiesMessage

// string deviceName = 1;
inline void ReadDevicePropertiesMessage::clear_devicename() {
  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& ReadDevicePropertiesMessage::devicename() const {
  // @@protoc_insertion_point(field_get:mascot.ReadDevicePropertiesMessage.deviceName)
  return devicename_.GetNoArena();
}
inline void ReadDevicePropertiesMessage::set_devicename(const ::std::string& value) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.ReadDevicePropertiesMessage.deviceName)
}
#if LANG_CXX11
inline void ReadDevicePropertiesMessage::set_devicename(::std::string&& value) {
  
  devicename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.ReadDevicePropertiesMessage.deviceName)
}
#endif
inline void ReadDevicePropertiesMessage::set_devicename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.ReadDevicePropertiesMessage.deviceName)
}
inline void ReadDevicePropertiesMessage::set_devicename(const char* value, size_t size) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.ReadDevicePropertiesMessage.deviceName)
}
inline ::std::string* ReadDevicePropertiesMessage::mutable_devicename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.ReadDevicePropertiesMessage.deviceName)
  return devicename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* ReadDevicePropertiesMessage::release_devicename() {
  // @@protoc_insertion_point(field_release:mascot.ReadDevicePropertiesMessage.deviceName)
  
  return devicename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void ReadDevicePropertiesMessage::set_allocated_devicename(::std::string* devicename) {
  if (devicename != NULL) {
    
  } else {
    
  }
  devicename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), devicename);
  // @@protoc_insertion_point(field_set_allocated:mascot.ReadDevicePropertiesMessage.deviceName)
}

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// DeviceProperties

// string deviceName = 1;
inline void DeviceProperties::clear_devicename() {
  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& DeviceProperties::devicename() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceProperties.deviceName)
  return devicename_.GetNoArena();
}
inline void DeviceProperties::set_devicename(const ::std::string& value) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.DeviceProperties.deviceName)
}
#if LANG_CXX11
inline void DeviceProperties::set_devicename(::std::string&& value) {
  
  devicename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.DeviceProperties.deviceName)
}
#endif
inline void DeviceProperties::set_devicename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.DeviceProperties.deviceName)
}
inline void DeviceProperties::set_devicename(const char* value, size_t size) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.DeviceProperties.deviceName)
}
inline ::std::string* DeviceProperties::mutable_devicename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.DeviceProperties.deviceName)
  return devicename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* DeviceProperties::release_devicename() {
  // @@protoc_insertion_point(field_release:mascot.DeviceProperties.deviceName)
  
  return devicename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void DeviceProperties::set_allocated_devicename(::std::string* devicename) {
  if (devicename != NULL) {
    
  } else {
    
  }
  devicename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), devicename);
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceProperties.deviceName)
}

// map<string, .mascot.AttributeValue> properties = 2;
inline int DeviceProperties::properties_size() const {
  return properties_.size();
}
inline const ::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >&
DeviceProperties::properties() const {
  // @@protoc_insertion_point(field_map:mascot.DeviceProperties.properties)
  return properties_.GetMap();
}
inline ::google::protobuf::Map< ::std::string, ::mascot::AttributeValue >*
DeviceProperties::mutable_properties() {
  // @@protoc_insertion_point(field_mutable_map:mascot.DeviceProperties.properties)
  return properties_.MutableMap();
}

// -------------------------------------------------------------------

// ReadDeviceAttributeMetaMessage

// string deviceName = 1;
inline void ReadDeviceAttributeMetaMessage::clear_devicename() {
  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& ReadDeviceAttributeMetaMessage::devicename() const {
  // @@protoc_insertion_point(field_get:mascot.ReadDeviceAttributeMetaMessage.deviceName)
  return devicename_.GetNoArena();
}
inline void ReadDeviceAttributeMetaMessage::set_devicename(const ::std::string& value) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.ReadDeviceAttributeMetaMessage.deviceName)
}
#if LANG_CXX11
inline void ReadDeviceAttributeMetaMessage::set_devicename(::std::string&& value) {
  
  devicename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.ReadDeviceAttributeMetaMessage.deviceName)
}
#endif
inline void ReadDeviceAttributeMetaMessage::set_devicename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.ReadDeviceAttributeMetaMessage.deviceName)
}
inline void ReadDeviceAttributeMetaMessage::set_devicename(const char* value, size_t size) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.ReadDeviceAttributeMetaMessage.deviceName)
}
inline ::std::string* ReadDeviceAttributeMetaMessage::mutable_devicename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.ReadDeviceAttributeMetaMessage.deviceName)
  return devicename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* ReadDeviceAttributeMetaMessage::release_devicename() {
  // @@protoc_insertion_point(field_release:mascot.ReadDeviceAttributeMetaMessage.deviceName)
  
  return devicename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void ReadDeviceAttributeMetaMessage::set_allocated_devicename(::std::string* devicename) {
  if (devicename != NULL) {
    
  } else {
    
  }
  devicename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), devicename);
  // @@protoc_insertion_point(field_set_allocated:mascot.ReadDeviceAttributeMetaMessage.deviceName)
}

// string attributeName = 2;
inline void ReadDeviceAttributeMetaMessage::clear_attributename() {
  attributename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& ReadDeviceAttributeMetaMessage::attributename() const {
  // @@protoc_insertion_point(field_get:mascot.ReadDeviceAttributeMetaMessage.attributeName)
  return attributename_.GetNoArena();
}
inline void ReadDeviceAttributeMetaMessage::set_attributename(const ::std::string& value) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.ReadDeviceAttributeMetaMessage.attributeName)
}
#if LANG_CXX11
inline void ReadDeviceAttributeMetaMessage::set_attributename(::std::string&& value) {
  
  attributename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.ReadDeviceAttributeMetaMessage.attributeName)
}
#endif
inline void ReadDeviceAttributeMetaMessage::set_attributename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.ReadDeviceAttributeMetaMessage.attributeName)
}
inline void ReadDeviceAttributeMetaMessage::set_attributename(const char* value, size_t size) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.ReadDeviceAttributeMetaMessage.attributeName)
}
inline ::std::string* ReadDeviceAttributeMetaMessage::mutable_attributename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.ReadDeviceAttributeMetaMessage.attributeName)
  return attributename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* ReadDeviceAttributeMetaMessage::release_attributename() {
  // @@protoc_insertion_point(field_release:mascot.ReadDeviceAttributeMetaMessage.attributeName)
  
  return attributename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void ReadDeviceAttributeMetaMessage::set_allocated_attributename(::std::string* attributename) {
  if (attributename != NULL) {
    
  } else {
    
  }
  attributename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), attributename);
  // @@protoc_insertion_point(field_set_allocated:mascot.ReadDeviceAttributeMetaMessage.attributeName)
}

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// DeviceAttributeMeta

// string deviceName = 1;
inline void DeviceAttributeMeta::clear_devicename() {
  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& DeviceAttributeMeta::devicename() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttributeMeta.deviceName)
  return devicename_.GetNoArena();
}
inline void DeviceAttributeMeta::set_devicename(const ::std::string& value) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.DeviceAttributeMeta.deviceName)
}
#if LANG_CXX11
inline void DeviceAttributeMeta::set_devicename(::std::string&& value) {
  
  devicename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.DeviceAttributeMeta.deviceName)
}
#endif
inline void DeviceAttributeMeta::set_devicename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.DeviceAttributeMeta.deviceName)
}
inline void DeviceAttributeMeta::set_devicename(const char* value, size_t size) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.DeviceAttributeMeta.deviceName)
}
inline ::std::string* DeviceAttributeMeta::mutable_devicename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.DeviceAttributeMeta.deviceName)
  return devicename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* DeviceAttributeMeta::release_devicename() {
  // @@protoc_insertion_point(field_release:mascot.DeviceAttributeMeta.deviceName)
  
  return devicename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void DeviceAttributeMeta::set_allocated_devicename(::std::string* devicename) {
  if (devicename != NULL) {
    
  } else {
    
  }
  devicename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), devicename);
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceAttributeMeta.deviceName)
}

// string attributeName = 2;
inline void DeviceAttributeMeta::clear_attributename() {
  attributename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& DeviceAttributeMeta::attributename() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttributeMeta.attributeName)
  return attributename_.GetNoArena();
}
inline void DeviceAttributeMeta::set_attributename(const ::std::string& value) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.DeviceAttributeMeta.attributeName)
}
#if LANG_CXX11
inline void DeviceAttributeMeta::set_attributename(::std::string&& value) {
  
  attributename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.DeviceAttributeMeta.attributeName)
}
#endif
inline void DeviceAttributeMeta::set_attributename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.DeviceAttributeMeta.attributeName)
}
inline void DeviceAttributeMeta::set_attributename(const char* value, size_t size) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.DeviceAttributeMeta.attributeName)
}
inline ::std::string* DeviceAttributeMeta::mutable_attributename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.DeviceAttributeMeta.attributeName)
  return attributename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* DeviceAttributeMeta::release_attributename() {
  // @@protoc_insertion_point(field_release:mascot.DeviceAttributeMeta.attributeName)
  
  return attributename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void DeviceAttributeMeta::set_allocated_attributename(::std::string* attributename) {
  if (attributename != NULL) {
    
  } else {
    
  }
  attributename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), attributename);
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceAttributeMeta.attributeName)
}

// map<string, string> meta = 3;
inline int DeviceAttributeMeta::meta_size() const {
  return meta_.size();
}
inline void DeviceAttributeMeta::clear_meta() {
  meta_.Clear();
}
inline const ::google::protobuf::Map< ::std::string, ::std::string >&
DeviceAttributeMeta::meta() const {
  // @@protoc_insertion_point(field_map:mascot.DeviceAttributeMeta.meta)
  return meta_.GetMap();
}
inline ::google::protobuf::Map< ::std::string, ::std::string >*
DeviceAttributeMeta::mutable_meta() {
  // @@protoc_insertion_point(field_mutable_map:mascot.DeviceAttributeMeta.meta)
  return meta_.MutableMap();
}

#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__
// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------


// @@protoc_insertion_point(namespace_scope)

}  // namespace mascot

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_device_5fproperties_2eproto__INCLUDED
